=== debian/changelog ===
containerd-app (2.0.2-0ubuntu2) plucky; urgency=medium

  * SECURITY UPDATE: Integer overflow.
    - debian/patches/CVE-2024-40635.patch: Add maxUserID and maxGroupID with
      limitations in ./pkg/oci/spec_opts.go.
    - CVE-2024-40635

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Tue, 25 Mar 2025 14:31:52 -0230

containerd-app (2.0.2-0ubuntu1) plucky; urgency=medium

  * New upstream version 2.0.2 (LP: #2085187, #2076166)
  * d/control:
    - build with golang 1.24 (LP: #2098664)
    - add missing B-D on procps
  * d/rules: add golang 1.24 to PATH
  * d/copyright: update copyright data

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 17 Feb 2025 10:52:33 -0300
