## containerd-app 2.0.5

=== debian/changelog ===
containerd-app (2.0.5-0ubuntu1~24.10.1) oracular; urgency=medium

  * Backport from questing to oracular (LP: #2110139)
  * d/control: build with golang 1.23
  * d/rules: add golang 1.23 to PATH

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Wed, 07 May 2025 11:51:13 -0300

containerd-app (2.0.5-0ubuntu1) questing; urgency=medium

  * d/t/basic-smoke: remove shell's -u option
  * New upstream version 2.0.5
  * d/p/CVE-2024-40635.patch: drop patch applied upstream
  * d/copyright: remove unused license text
  * d/control:
    - Replace pkg-config with pkgconf
    - Bump Standards-Version

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 06 May 2025 19:50:35 -0300
