=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
                go-md2man,
-               golang-1.24-go,
+               golang-1.23-go,
                libbtrfs-dev | btrfs-progs (<< 4.16.1~),
                libseccomp-dev,
-               pkg-config,
+               pkgconf,
                procps
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://containerd.io
 Vcs-Git: https://github.com/canonical/containerd-app.git
 Vcs-Browser: https://github.com/canonical/containerd-app
