=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
                go-md2man,
-               golang-1.23-go,
+               golang-1.24-go,
                libbtrfs-dev | btrfs-progs (<< 4.16.1~),
                libseccomp-dev,
                pkgconf,
@@ -19,6 +19,8 @@
 Architecture: linux-any
 Depends: runc, ${misc:Depends}, ${shlibs:Depends}
 Breaks: docker.io (<< 19.03.13-0ubuntu4)
+Conflicts: containerd
+Replaces: containerd
 Built-Using: ${misc:Built-Using}
 Description: daemon to control runC
  Containerd is a daemon to control runC, built for performance and density.
@@ -27,3 +29,7 @@
  migration of containers.
  .
  This package contains the binaries.
+ .
+ This package is frequently updated to new Containerd upstream versions, which
+ may include new features and often introduce breaking changes. If you want
+ stability, use containerd-stable instead.
